<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEligibleSensorName ArrayType
 * @subpackage Arrays
 */
class ArrayOfEligibleSensorName extends AbstractStructArrayBase
{
    /**
     * The EligibleSensorName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\EligibleSensorName[]
     */
    public $EligibleSensorName;
    /**
     * Constructor method for ArrayOfEligibleSensorName
     * @uses ArrayOfEligibleSensorName::setEligibleSensorName()
     * @param \CustomerManagement\StructType\EligibleSensorName[] $eligibleSensorName
     */
    public function __construct(array $eligibleSensorName = array())
    {
        $this
            ->setEligibleSensorName($eligibleSensorName);
    }
    /**
     * Get EligibleSensorName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\EligibleSensorName[]|null
     */
    public function getEligibleSensorName()
    {
        return isset($this->EligibleSensorName) ? $this->EligibleSensorName : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEligibleSensorName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEligibleSensorName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEligibleSensorNameForArrayConstraintsFromSetEligibleSensorName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEligibleSensorNameEligibleSensorNameItem) {
            // validation for constraint: itemType
            if (!$arrayOfEligibleSensorNameEligibleSensorNameItem instanceof \CustomerManagement\StructType\EligibleSensorName) {
                $invalidValues[] = is_object($arrayOfEligibleSensorNameEligibleSensorNameItem) ? get_class($arrayOfEligibleSensorNameEligibleSensorNameItem) : sprintf('%s(%s)', gettype($arrayOfEligibleSensorNameEligibleSensorNameItem), var_export($arrayOfEligibleSensorNameEligibleSensorNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EligibleSensorName property can only contain items of type \CustomerManagement\StructType\EligibleSensorName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EligibleSensorName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\EligibleSensorName[] $eligibleSensorName
     * @return \CustomerManagement\ArrayType\ArrayOfEligibleSensorName
     */
    public function setEligibleSensorName(array $eligibleSensorName = array())
    {
        // validation for constraint: array
        if ('' !== ($eligibleSensorNameArrayErrorMessage = self::validateEligibleSensorNameForArrayConstraintsFromSetEligibleSensorName($eligibleSensorName))) {
            throw new \InvalidArgumentException($eligibleSensorNameArrayErrorMessage, __LINE__);
        }
        if (is_null($eligibleSensorName) || (is_array($eligibleSensorName) && empty($eligibleSensorName))) {
            unset($this->EligibleSensorName);
        } else {
            $this->EligibleSensorName = $eligibleSensorName;
        }
        return $this;
    }
    /**
     * Add item to EligibleSensorName value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\EligibleSensorName $item
     * @return \CustomerManagement\ArrayType\ArrayOfEligibleSensorName
     */
    public function addToEligibleSensorName(\CustomerManagement\StructType\EligibleSensorName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\EligibleSensorName) {
            throw new \InvalidArgumentException(sprintf('The EligibleSensorName property can only contain items of type \CustomerManagement\StructType\EligibleSensorName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EligibleSensorName[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\EligibleSensorName|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\EligibleSensorName|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\EligibleSensorName|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\EligibleSensorName|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\EligibleSensorName|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EligibleSensorName
     */
    public function getAttributeName()
    {
        return 'EligibleSensorName';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfEligibleSensorName
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
